<template>
  <NuxtLayout :name="'auth'">
    <div class="w-full bg-transparent flex">
      <div class="w-full bg-white p-8 rounded-lg shadow-xl mx-auto mb-10">
        <h1 class="text-4xl mb-8 text-center text-slate-900 lg:hidden">
          Aplikasi Manajemen PDF
        </h1>
        <DynamicForm :isLoading="isLoading" :fields="fields" :formTitle="formTitle" :submitName="submitName"
          :onSubmit="onSubmit" />
        <hr class="my-2" />
        <div class="mb-4 w-full flex">
          <div class="w-1/2">
            <span class="block">
              Don't have account?
              <NuxtLink class="block text-blue-500" to="/register">Register</NuxtLink>
            </span>
          </div>
          <div class="w-1/2">
            <span class="block">
              <a class="block text-right text-yellow-500" href="#">Forgot password?</a>
            </span>
          </div>
        </div>
      </div>
    </div>
  </NuxtLayout>
</template>

<script lang="ts">

interface formTemplate {
  email: string;
  password: string;
}

export default {
  data() {
    return {
      formTitle: "Login",
      submitName: "Login",
      isLoading: false,
      fields: [
        { id: "username", name: "Username", type: "username", value: "" },
        { id: "password", name: "Password", type: "password", value: "" },
      ],
    };
  },
  methods: {
    onSubmit(data: formTemplate) {
      this.isLoading = true;
      const toastStore = useToastStore();

      this.$api
        .post(`/login/`, data)
        .then((response) => {
          console.log(response)
          localStorage.setItem("access_token", response.data.access_token);
          toastStore.showToast('Login successfull', 'success')
          this.$router.push("/application");
        })
        .catch((error) => {
          console.log(error)
          const detail = error.response.data.detail;
          let message = "";
          if (detail[0].msg) {
            message = detail[0].msg;
          } else {
            message = detail;
          }
          toastStore.showToast(message, 'danger')
        }).finally(() => {
          this.isLoading = false;
        })
    },
  },
};
</script>
